Index: uspace/srv/devman/devman.c
===================================================================
--- uspace/srv/devman/devman.c	(revision 89ce401a6041808200871d79a9a8dc5367992722)
+++ uspace/srv/devman/devman.c	(revision 2480e1950e6008ddc8de893c9387eea1d9ce607e)
@@ -341,5 +341,5 @@
 driver_t * find_best_match_driver(driver_list_t *drivers_list, node_t *node)
 {
-	printf(NAME ": find_best_match_driver for device '%s' \n", node->pathname);
+	//printf(NAME ": find_best_match_driver for device '%s' \n", node->pathname);
 	driver_t *best_drv = NULL, *drv = NULL;
 	int best_score = 0, score = 0;
@@ -371,4 +371,6 @@
 void attach_driver(node_t *node, driver_t *drv) 
 {
+	printf(NAME ": attach_driver %s to device %s\n", drv->name, node->pathname);
+	
 	fibril_mutex_lock(&drv->driver_mutex);
 	
@@ -524,5 +526,5 @@
 bool assign_driver(node_t *node, driver_list_t *drivers_list) 
 {
-	printf(NAME ": assign_driver\n");
+	//printf(NAME ": assign_driver\n");
 	
 	// find the driver which is the most suitable for handling this device
@@ -620,5 +622,5 @@
 bool insert_dev_node(dev_tree_t *tree, node_t *node, char *dev_name, node_t *parent)
 {
-	printf(NAME ": insert_dev_node\n");
+	// printf(NAME ": insert_dev_node\n");
 	
 	assert(NULL != node && NULL != tree && NULL != dev_name);
@@ -709,4 +711,6 @@
 			return dev;			
 		}
+		
+		link = link->next;
 	}	
 	
Index: uspace/srv/devman/main.c
===================================================================
--- uspace/srv/devman/main.c	(revision 89ce401a6041808200871d79a9a8dc5367992722)
+++ uspace/srv/devman/main.c	(revision 2480e1950e6008ddc8de893c9387eea1d9ce607e)
@@ -142,4 +142,6 @@
 	}
 	
+	ipc_answer_0(callid, EOK);
+	
 	match_id->score = IPC_GET_ARG1(call);
 	
@@ -147,4 +149,5 @@
 	if (EOK != rc) {
 		delete_match_id(match_id);
+		printf(NAME ": devman_receive_match_id - failed to receive match id string.\n");
 		return rc;
 	}
@@ -157,5 +160,5 @@
 
 static int devman_receive_match_ids(ipcarg_t match_count, match_id_list_t *match_ids) 
-{
+{	
 	int ret = EOK;
 	size_t i;
@@ -170,5 +173,5 @@
 static void devman_add_child(ipc_callid_t callid, ipc_call_t *call, driver_t *driver)
 {
-	printf(NAME ": devman_add_child\n");
+	// printf(NAME ": devman_add_child\n");
 	
 	device_handle_t parent_handle = IPC_GET_ARG1(*call);
@@ -188,5 +191,5 @@
 		return;
 	}
-	printf(NAME ": newly added child device's name is '%s'.\n", dev_name);
+	// printf(NAME ": newly added child device's name is '%s'.\n", dev_name);
 	
 	node_t *node = create_dev_node();
@@ -196,4 +199,6 @@
 		return;
 	}	
+	
+	printf(NAME ": devman_add_child %s\n", node->pathname);
 	
 	devman_receive_match_ids(match_count, &node->match_ids);
@@ -261,5 +266,5 @@
 	
 	device_handle_t handle = IPC_GET_ARG2(*icall);
-	printf(NAME ": devman_forward - trying to forward connection to device with handle %x.\n", handle);
+	// printf(NAME ": devman_forward - trying to forward connection to device with handle %x.\n", handle);
 	
 	node_t *dev = find_dev_node(&device_tree, handle);
@@ -297,5 +302,6 @@
 		return;
 	}
-	printf(NAME ": devman_forward: forward to driver %s with phone %d.\n", driver->name, driver->phone);
+	printf(NAME ": devman_forward: forward connection to device %s to driver %s with phone %d.\n", 
+		dev->pathname, driver->name, driver->phone);
 	ipc_forward_fast(iid, driver->phone, method, dev->handle, 0, IPC_FF_NONE);	
 }
Index: uspace/srv/drivers/pciintel/pci.c
===================================================================
--- uspace/srv/drivers/pciintel/pci.c	(revision 89ce401a6041808200871d79a9a8dc5367992722)
+++ uspace/srv/drivers/pciintel/pci.c	(revision 2480e1950e6008ddc8de893c9387eea1d9ce607e)
@@ -156,5 +156,5 @@
 	match_id = create_match_id();
 	if (NULL != match_id) {
-		asprintf(&match_id->id, "pci/ven=%04x,dev=%04x", dev_data->vendor_id, dev_data->device_id);
+		asprintf(&match_id->id, "pci/ven=%04x&dev=%04x", dev_data->vendor_id, dev_data->device_id);
 		match_id->score = 90;
 		add_match_id(&dev->match_ids, match_id);
@@ -198,5 +198,5 @@
 			
 			create_pci_dev_name(dev);
-			printf(NAME ": adding new device name %s.\n", dev->name);
+			printf(NAME ": adding new child device %s.\n", dev->name);
 			
 			create_pci_match_ids(dev);
@@ -208,4 +208,6 @@
 				continue;
 			}
+			
+			//printf(NAME ": new device %s was successfully registered by device manager.\n", dev->name);
 			
 			if (header_type == PCI_HEADER_TYPE_BRIDGE || header_type == PCI_HEADER_TYPE_CARDBUS ) {