Index: kernel/Makefile
===================================================================
--- kernel/Makefile	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ kernel/Makefile	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -105,5 +105,5 @@
 CLANG_CFLAGS = $(INCLUDES_FLAGS) -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
 	-ffreestanding -fno-builtin -nostdlib -nostdinc \
-	-Wall -Wextra -Wno-unused-parameter -Wmissing-prototypes \
+	-Wall -Werror -Wextra -Wno-unused-parameter -Wmissing-prototypes \
 	-Werror-implicit-function-declaration -Wwrite-strings \
 	-integrated-as \
Index: kernel/generic/include/cc.h
===================================================================
--- kernel/generic/include/cc.h	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
+++ kernel/generic/include/cc.h	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -0,0 +1,50 @@
+/*
+ * Copyright (c) 2013 Vojtech Horky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup generic
+ * @{
+ */
+/** @file
+ * Macros related to used compiler (such as GCC-specific attributes).
+ */
+
+#ifndef KERN_CC_H_
+#define KERN_CC_H_
+
+#ifndef __clang__
+#define ATTRIBUTE_OPTIMIZE(opt) \
+	__attribute__ ((optimize(opt)))
+#else
+#define ATTRIBUTE_OPTIMIZE(opt)
+#endif
+
+
+#endif
+
+/** @}
+ */
Index: kernel/generic/include/lib/memfnc.h
===================================================================
--- kernel/generic/include/lib/memfnc.h	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ kernel/generic/include/lib/memfnc.h	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -37,9 +37,10 @@
 
 #include <typedefs.h>
+#include <cc.h>
 
 extern void *memset(void *, int, size_t)
-    __attribute__ ((optimize("-fno-tree-loop-distribute-patterns")));
+    ATTRIBUTE_OPTIMIZE("-fno-tree-loop-distribute-patterns");
 extern void *memcpy(void *, const void *, size_t)
-    __attribute__ ((optimize("-fno-tree-loop-distribute-patterns")));
+    ATTRIBUTE_OPTIMIZE("-fno-tree-loop-distribute-patterns");
 
 #endif
Index: kernel/test/print/print4.c
===================================================================
--- kernel/test/print/print4.c	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ kernel/test/print/print4.c	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -36,5 +36,5 @@
 	uint8_t group;
 	for (group = 1; group < 4; group++) {
-		TPRINTF("%#" PRIx8 ": ", group << 5);
+		TPRINTF("%#x: ", group << 5);
 		
 		uint8_t index;
@@ -52,5 +52,5 @@
 	
 	for (group = 4; group < 8; group++) {
-		TPRINTF("%#" PRIx8 ": ", group << 5);
+		TPRINTF("%#x: ", group << 5);
 		
 		uint8_t index;
Index: tools/mkext2.py
===================================================================
--- tools/mkext2.py	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ tools/mkext2.py	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -39,4 +39,7 @@
 import uuid
 from imgutil import *
+
+if sys.version >= '3':
+	xrange = range
 
 GDE_SIZE = 32
@@ -530,6 +533,6 @@
 		data.flags = 0
 		blockconv = lambda x: 0 if x == None else x
-		data.direct_blocks = map(blockconv, self.direct)
-		data.indirect_blocks = map(blockconv, self.indirect)
+		data.direct_blocks = list(map(blockconv, self.direct))
+		data.indirect_blocks = list(map(blockconv, self.indirect))
 		data.version = 0
 		data.file_acl = 0
@@ -567,5 +570,5 @@
 		head.inode_type = self.type
 		inode.write(head.pack())
-		inode.write(self.name+'\0')
+		inode.write(self.name+'\0'.encode())
 		inode.align_pos(4)
 
Index: uspace/app/bdsh/cmds/modules/help/help.c
===================================================================
--- uspace/app/bdsh/cmds/modules/help/help.c	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/app/bdsh/cmds/modules/help/help.c	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -98,5 +98,4 @@
 	builtin_t *cmd;
 	module_t *mod;
-	unsigned int i;
 
 	printf("\n  Bdsh built-in commands:\n");
@@ -104,5 +103,5 @@
 
 	/* First, show a list of built in commands that are available in this mode */
-	for (cmd = builtins; cmd->name != NULL; cmd++, i++) {
+	for (cmd = builtins; cmd->name != NULL; cmd++) {
 			if (is_builtin_alias(cmd->name))
 				printf("   %-16s\tAlias for `%s'\n", cmd->name,
@@ -112,8 +111,6 @@
 	}
 
-	i = 0;
-
 	/* Now, show a list of module commands that are available in this mode */
-	for (mod = modules; mod->name != NULL; mod++, i++) {
+	for (mod = modules; mod->name != NULL; mod++) {
 			if (is_module_alias(mod->name))
 				printf("   %-16s\tAlias for `%s'\n", mod->name,
Index: uspace/app/bdsh/cmds/modules/pwd/pwd.c
===================================================================
--- uspace/app/bdsh/cmds/modules/pwd/pwd.c	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/app/bdsh/cmds/modules/pwd/pwd.c	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -55,5 +55,5 @@
 	}
 
-	memset(buff, 0, sizeof(buff));
+	memset(buff, 0, PATH_MAX);
 	getcwd(buff, PATH_MAX);
 
Index: uspace/app/bdsh/cmds/modules/rm/rm.c
===================================================================
--- uspace/app/bdsh/cmds/modules/rm/rm.c	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/app/bdsh/cmds/modules/rm/rm.c	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -99,13 +99,13 @@
 	if (NULL == (rm->nwd = (char *) malloc(PATH_MAX)))
 		return 0;
-	memset(rm->nwd, 0, sizeof(rm->nwd));
+	memset(rm->nwd, 0, PATH_MAX);
 
 	if (NULL == (rm->owd = (char *) malloc(PATH_MAX)))
 		return 0;
-	memset(rm->owd, 0, sizeof(rm->owd));
+	memset(rm->owd, 0, PATH_MAX);
 
 	if (NULL == (rm->cwd = (char *) malloc(PATH_MAX)))
 		return 0;
-	memset(rm->cwd, 0, sizeof(rm->cwd));
+	memset(rm->cwd, 0, PATH_MAX);
 
 	chdir(".");
@@ -298,5 +298,5 @@
 			break;
 		}
-		memset(buff, 0, sizeof(buff));
+		memset(buff, 0, len);
 		snprintf(buff, len, "%s", argv[i]);
 
Index: uspace/app/bdsh/exec.c
===================================================================
--- uspace/app/bdsh/exec.c	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/app/bdsh/exec.c	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -83,5 +83,5 @@
 	/* We now have n places to look for the command */
 	for (i = 0; search_dir[i] != NULL; i++) {
-		memset(found, 0, sizeof(found));
+		memset(found, 0, PATH_MAX);
 		snprintf(found, PATH_MAX, "%s/%s", search_dir[i], cmd);
 		if (-1 != try_access(found)) {
Index: uspace/app/edit/search_impl.h
===================================================================
--- uspace/app/edit/search_impl.h	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/app/edit/search_impl.h	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -40,5 +40,5 @@
 
 /** Search state */
-typedef struct search {
+struct search {
 	/* Note: This structure is opaque for the user. */
 
@@ -49,5 +49,5 @@
 	void *client_data;
 	search_ops_t ops;
-} search_t;
+};
 
 #endif
Index: uspace/app/edit/sheet_impl.h
===================================================================
--- uspace/app/edit/sheet_impl.h	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/app/edit/sheet_impl.h	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -40,5 +40,5 @@
 
 /** Sheet */
-typedef struct sheet {
+struct sheet {
 	/* Note: This structure is opaque for the user. */
 
@@ -48,5 +48,5 @@
 
 	list_t tags;
-} sheet_t;
+};
 
 #endif
Index: uspace/drv/bus/usb/vhc/hub/virthubops.c
===================================================================
--- uspace/drv/bus/usb/vhc/hub/virthubops.c	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/drv/bus/usb/vhc/hub/virthubops.c	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -299,5 +299,5 @@
     size_t *act_size)
 {
-	int rc;
+	int rc = ENOTSUP;
 	size_t port = request->index - 1;
 	usb_hub_class_feature_t feature = request->value;
Index: uspace/drv/char/ps2mouse/ps2mouse.c
===================================================================
--- uspace/drv/char/ps2mouse/ps2mouse.c	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/drv/char/ps2mouse/ps2mouse.c	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -70,6 +70,7 @@
 #define PS2_BUTTON_MASK(button) (1 << button)
 
-#define MOUSE_READ_BYTE_TEST(sess, value) \
+#define MOUSE_READ_BYTE_TEST(sess, value_) \
 do { \
+	uint8_t value = (value_); \
 	uint8_t data = 0; \
 	const ssize_t size = chardev_read(sess, &data, 1); \
@@ -78,13 +79,14 @@
 		return size < 0 ? size : EIO; \
 	} \
-	if (data != (value)) { \
+	if (data != value) { \
 		ddf_msg(LVL_DEBUG, "Failed testing byte: got %hhx vs. %hhx)", \
-		    data, (value)); \
+		    data, value); \
 		return EIO; \
 	} \
 } while (0)
 
-#define MOUSE_WRITE_BYTE(sess, value) \
+#define MOUSE_WRITE_BYTE(sess, value_) \
 do { \
+	uint8_t value = (value_); \
 	uint8_t data = (value); \
 	const ssize_t size = chardev_write(sess, &data, 1); \
Index: uspace/drv/nic/rtl8139/driver.c
===================================================================
--- uspace/drv/nic/rtl8139/driver.c	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/drv/nic/rtl8139/driver.c	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -620,5 +620,5 @@
 		if (size == 0 || size > RTL8139_FRAME_MAX_LENGTH) {
 			ddf_msg(LVL_ERROR, "Receiver error -> receiver reset (size: %4" PRIu16 ", "
-			    "header 0x%4" PRIx16 ". Offset: %d)", size, frame_header,
+			    "header 0x%4" PRIx32 ". Offset: %" PRIu16 ")", size, frame_header,
 			    rx_offset);
 			goto rx_err;
Index: uspace/lib/c/generic/devman.c
===================================================================
--- uspace/lib/c/generic/devman.c	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/lib/c/generic/devman.c	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -413,5 +413,5 @@
 	sysarg_t dretval;
 	
-	exch = devman_exchange_begin_blocking(LOC_PORT_CONSUMER);
+	exch = devman_exchange_begin_blocking(DEVMAN_CLIENT);
 	
 	ipc_call_t answer;
Index: uspace/lib/c/include/bd_srv.h
===================================================================
--- uspace/lib/c/include/bd_srv.h	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/lib/c/include/bd_srv.h	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -57,5 +57,5 @@
 } bd_srv_t;
 
-typedef struct bd_ops {
+struct bd_ops {
 	int (*open)(bd_srvs_t *, bd_srv_t *);
 	int (*close)(bd_srv_t *);
@@ -65,5 +65,5 @@
 	int (*get_block_size)(bd_srv_t *, size_t *);
 	int (*get_num_blocks)(bd_srv_t *, aoff64_t *);
-} bd_ops_t;
+};
 
 extern void bd_srvs_init(bd_srvs_t *);
Index: uspace/lib/c/include/cc.h
===================================================================
--- uspace/lib/c/include/cc.h	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
+++ uspace/lib/c/include/cc.h	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -0,0 +1,50 @@
+/*
+ * Copyright (c) 2013 Vojtech Horky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ * Macros related to used compiler (such as GCC-specific attributes).
+ */
+
+#ifndef LIBC_CC_H_
+#define LIBC_CC_H_
+
+#ifndef __clang__
+#define ATTRIBUTE_OPTIMIZE(opt) \
+	__attribute__ ((optimize(opt)))
+#else
+#define ATTRIBUTE_OPTIMIZE(opt)
+#endif
+
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/io/con_srv.h
===================================================================
--- uspace/lib/c/include/io/con_srv.h	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/lib/c/include/io/con_srv.h	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -66,5 +66,5 @@
 } con_srv_t;
 
-typedef struct con_ops {
+struct con_ops {
 	int (*open)(con_srvs_t *, con_srv_t *);
 	int (*close)(con_srv_t *);
@@ -83,5 +83,5 @@
 	void (*set_cursor_visibility)(con_srv_t *, bool);
 	int (*get_event)(con_srv_t *, cons_event_t *);
-} con_ops_t;
+};
 
 extern void con_srvs_init(con_srvs_t *);
Index: uspace/lib/c/include/mem.h
===================================================================
--- uspace/lib/c/include/mem.h	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/lib/c/include/mem.h	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -37,9 +37,10 @@
 
 #include <sys/types.h>
+#include <cc.h>
 
 extern void *memset(void *, int, size_t)
-    __attribute__ ((optimize("-fno-tree-loop-distribute-patterns")));
+    ATTRIBUTE_OPTIMIZE("-fno-tree-loop-distribute-patterns");
 extern void *memcpy(void *, const void *, size_t)
-    __attribute__ ((optimize("-fno-tree-loop-distribute-patterns")));
+    ATTRIBUTE_OPTIMIZE("-fno-tree-loop-distribute-patterns");
 extern void *memmove(void *, const void *, size_t);
 extern int memcmp(const void *, const void *, size_t);
Index: uspace/lib/draw/drawctx.h
===================================================================
--- uspace/lib/draw/drawctx.h	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/lib/draw/drawctx.h	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -47,5 +47,5 @@
 #include "font.h"
 
-typedef struct drawctx {
+struct drawctx {
 	link_t link;
 	list_t list;
@@ -62,5 +62,5 @@
 	sysarg_t clip_width;
 	sysarg_t clip_height;
-} drawctx_t;
+};
 
 extern void drawctx_init(drawctx_t *, surface_t *);
Index: uspace/lib/gui/connection.h
===================================================================
--- uspace/lib/gui/connection.h	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/lib/gui/connection.h	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -38,7 +38,5 @@
 
 #include <sys/types.h>
-
-struct widget;
-typedef struct widget widget_t;
+#include "widget.h"
 
 typedef sysarg_t signal_t;
Index: uspace/lib/gui/widget.h
===================================================================
--- uspace/lib/gui/widget.h	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/lib/gui/widget.h	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -51,5 +51,5 @@
  * any derived widget structure.
  */
-typedef struct widget {
+struct widget {
 	link_t link;
 	widget_t *parent; /**< Parent widget of this widget. NULL for root widget. */
@@ -116,5 +116,5 @@
 	 * also acquire or release mouse grab. */
 	void (*handle_position_event)(widget_t *, pos_event_t);
-} widget_t;
+};
 
 /*
Index: uspace/lib/gui/window.h
===================================================================
--- uspace/lib/gui/window.h	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/lib/gui/window.h	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -47,5 +47,5 @@
 #include "widget.h"
 
-typedef struct window {
+struct window {
 	bool is_main; /**< True for the main window of the application. */
 	bool is_decorated; /**< True if the window decorations should be rendered. */
@@ -60,5 +60,5 @@
 	fibril_mutex_t guard; /**< Mutex guarding window surface. */
 	surface_t *surface; /**< Window surface shared with compositor. */
-} window_t;
+};
 
 /**
Index: uspace/lib/usbhid/src/hidiface.c
===================================================================
--- uspace/lib/usbhid/src/hidiface.c	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/lib/usbhid/src/hidiface.c	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -90,5 +90,5 @@
 		return EINVAL;
 	
-	if ((buf == NULL))
+	if (buf == NULL)
 		return ENOMEM;
 	
@@ -184,5 +184,5 @@
 		return EINVAL;
 	
-	if ((buf == NULL))
+	if (buf == NULL)
 		return ENOMEM;
 	
Index: uspace/srv/hid/input/port/adb.c
===================================================================
--- uspace/srv/hid/input/port/adb.c	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/srv/hid/input/port/adb.c	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -118,5 +118,5 @@
 		ipc_callid_t callid = async_get_call(&call);
 
-		int retval;
+		int retval = EOK;
 		
 		if (!IPC_GET_IMETHOD(call)) {
Index: uspace/srv/hid/input/port/adb_mouse.c
===================================================================
--- uspace/srv/hid/input/port/adb_mouse.c	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/srv/hid/input/port/adb_mouse.c	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -54,5 +54,5 @@
 		ipc_callid_t callid = async_get_call(&call);
 		
-		int retval;
+		int retval = EOK;
 		
 		if (!IPC_GET_IMETHOD(call)) {
Index: uspace/srv/hid/input/port/chardev.c
===================================================================
--- uspace/srv/hid/input/port/chardev.c	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/srv/hid/input/port/chardev.c	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -148,5 +148,5 @@
 		}
 
-		int retval;
+		int retval = EOK;
 
 		switch (IPC_GET_IMETHOD(call)) {
Index: uspace/srv/hid/isdv4_tablet/isdv4.h
===================================================================
--- uspace/srv/hid/isdv4_tablet/isdv4.h	(revision 3de67b4cff4994af4a74b190c5b094f45c15b561)
+++ uspace/srv/hid/isdv4_tablet/isdv4.h	(revision 4339f0924af05ae37c66754e2898e53c5b59d049)
@@ -76,5 +76,5 @@
 } isdv4_source_type_t;
 
-typedef struct isdv4_event {
+struct isdv4_event {
 	isdv4_event_type_t type;
 	isdv4_source_type_t source;
@@ -83,5 +83,5 @@
 	unsigned int pressure;
 	unsigned int button;
-} isdv4_event_t;
+};
 
 extern int isdv4_init(isdv4_state_t *, async_sess_t *, isdv4_event_fn);